---
title: Using the MediaStream Recording API
slug: Web/API/MediaStream_Recording_API/Using_the_MediaStream_Recording_API
tags:
  - API
  - Example
  - Guide
  - MediaRecorder
  - MediaStream Recording API
  - NeedsUpdate
  - Tutorial
---
<div>{{DefaultAPISidebar("MediaStream Recording")}}</div>

<div class="summary">
<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/MediaStream_Recording_API">MediaStream Recording API</a> makes it easy to record audio and/or video streams. When used with {{domxref("MediaDevices.getUserMedia()","navigator.mediaDevices.getUserMedia()")}}, it provides an easy way to record from the user's input devices and instantly use the result in web apps.</span> Both audio and video may be recorded, separately or together. This article aims to provide a basic guide on how to use the MediaRecorder interface, which provides this API.</p>
</div>

<h2 id="A_sample_application_Web_Dictaphone">A sample application: Web Dictaphone</h2>

<p><img alt="An image of the Web dictaphone sample app - a sine wave sound visualization, then record and stop buttons, then an audio jukebox of recorded tracks that can be played back." src="https://mdn.mozillademos.org/files/7885/web-dictaphone.png" style="display: block; margin: 0px auto;"></p>

<p>To demonstrate basic usage of the MediaRecorder API, we have built a web-based dictaphone. It allows you to record snippets of audio and then play them back. It even gives you a visualization of your device's sound input, using the Web Audio API. We'll concentrate on the recording and playback functionality for this article.</p>

<p>You can see this <a href="https://mdn.github.io/web-dictaphone/">demo running live</a>, or <a href="https://github.com/mdn/web-dictaphone">grab the source code</a> on GitHub.</p>

<h2 id="CSS_goodies">CSS goodies</h2>

<p>The HTML is pretty simple in this app, so we won't go through it here; there are a couple of slightly more interesting bits of CSS worth mentioning, however, so we'll discuss them below. If you are not interested in CSS and want to get straight to the JavaScript, skip to the {{anch("Basic app setup")}} section.</p>

<h3 id="Keeping_the_interface_constrained_to_the_viewport_regardless_of_device_height_with_calc">Keeping the interface constrained to the viewport, regardless of device height, with calc()</h3>

<p>The {{cssxref("calc")}} function is one of those useful little utility features that's cropped up in CSS that doesn't look like much initially, but soon starts to make you think "Wow, why didn't we have this before? Why was CSS2 layout so awkward?" It allows you do a calculation to determine the computed value of a CSS unit, mixing different units in the process.</p>

<p>For example, in Web Dictaphone we have three main UI areas, stacked vertically. We wanted to give the first two (the header and the controls) fixed heights:</p>

<pre class="brush: css notranslate">header {
  height: 70px;
}

.main-controls {
  padding-bottom: 0.7rem;
  height: 170px;
}</pre>

<p>However, we wanted to make the third area (which contains the recorded samples you can play back) take up whatever space is left, regardless of the device height. Flexbox could be the answer here, but it's a bit overkill for such a simple layout. Instead, the problem was solved by making the third container's height equal to 100% of the parent height, minus the heights and padding of the other two:</p>

<pre class="brush: css;highlight[4] notranslate">.sound-clips {
  box-shadow: inset 0 3px 4px rgba(0,0,0,0.7);
  background-color: rgba(0,0,0,0.1);
  height: calc(100% - 240px - 0.7rem);
  overflow: scroll;
}</pre>

<div class="note">
<p><strong>Note</strong>: <code>calc()</code> has good support across modern browsers too, even going back to Internet Explorer 9.</p>
</div>

<h3 id="Checkbox_hack_for_showinghiding">Checkbox hack for showing/hiding</h3>

<p>This is fairly well documented already, but we thought we'd give a mention to the checkbox hack, which abuses the fact that you can click on the {{htmlelement("label")}} of a checkbox to toggle it checked/unchecked. In Web Dictaphone this powers the Information screen, which is shown/hidden by clicking the question mark icon in the top right hand corner. First of all, we style the <code>&lt;label&gt;</code> how we want it, making sure that it has enough z-index to always sit above the other elements and therefore be focusable/clickable:</p>

<pre class="brush: css notranslate">label {
    font-family: 'NotoColorEmoji';
    font-size: 3rem;
    position: absolute;
    top: 2px;
    right: 3px;
    z-index: 5;
    cursor: pointer;
}</pre>

<p>Then we hide the actual checkbox, because we don't want it cluttering up our UI:</p>

<pre class="brush: css notranslate">input[type=checkbox] {
   position: absolute;
   top: -100px;
}</pre>

<p>Next, we style the Information screen (wrapped in an {{htmlelement("aside")}} element) how we want it, give it fixed position so that it doesn't appear in the layout flow and affect the main UI, transform it to the position we want it to sit in by default, and give it a transition for smooth showing/hiding:</p>

<pre class="brush: css notranslate">aside {
   position: fixed;
   top: 0;
   left: 0;
   text-shadow: 1px 1px 1px black;
   width: 100%;
   height: 100%;
   transform: translateX(100%);
   transition: 0.6s all;
   background-color: #999;
    background-image: linear-gradient(to top right, rgba(0,0,0,0), rgba(0,0,0,0.5));
}</pre>

<p>Last, we write a rule to say that when the checkbox is checked (when we click/focus the label), the adjacent <code>&lt;aside&gt;</code> element will have its horizontal translation value changed and transition smoothly into view:</p>

<pre class="brush: css notranslate">input[type=checkbox]:checked ~ aside {
  transform: translateX(0);
}</pre>

<h2 id="Basic_app_setup">Basic app setup</h2>

<p>To grab the media stream we want to capture, we use <code>getUserMedia()</code>. We then use the MediaRecorder API to record the stream, and output each recorded snippet into the source of a generated {{htmlelement("audio")}} element so it can be played back.</p>

<p>We'll declare some variables for the record and stop buttons, and the {{htmlelement("article")}} that will contain the generated audio players:</p>

<pre class="brush: js notranslate">const record = document.querySelector('.record');
const stop = document.querySelector('.stop');
const soundClips = document.querySelector('.sound-clips');</pre>

<p>Finally for this section, we set up the basic <code>getUserMedia</code> structure:</p>

<pre class="brush: js notranslate">if (navigator.mediaDevices &amp;&amp; navigator.mediaDevices.getUserMedia) {
   console.log('getUserMedia supported.');
   navigator.mediaDevices.getUserMedia (
      // constraints - only audio needed for this app
      {
         audio: true
      })

      // Success callback
      .then(function(stream) {

      })

      // Error callback
      .catch(function(err) {
         console.log('The following <code>getUserMedia</code> error occurred: ' + err);
      }
   );
} else {
   console.log('getUserMedia not supported on your browser!');
}</pre>

<p>The whole thing is wrapped in a test that checks whether <code>getUserMedia</code> is supported before running anything else. Next, we call <code>getUserMedia()</code> and inside it define:</p>

<ul>
 <li><strong>The constraints</strong>: Only audio is to be captured for our dictaphone.</li>
 <li><strong>The success callback</strong>: This code is run once the <code>getUserMedia</code> call has been completed successfully.</li>
 <li><strong>The error/failure callback</strong>: The code is run if the <code>getUserMedia</code> call fails for whatever reason.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: All of the code below is placed inside the <code>getUserMedia</code> success callback.</p>
</div>

<h2 id="Capturing_the_media_stream">Capturing the media stream</h2>

<p>Once <code>getUserMedia</code> has created a media stream successfully, you create a new Media Recorder instance with the <code>MediaRecorder()</code> constructor and pass it the stream directly. This is your entry point into using the MediaRecorder API — the stream is now ready to be captured into a {{domxref("Blob")}}, in the default encoding format of your browser.</p>

<pre class="brush: js notranslate">const mediaRecorder = new MediaRecorder(stream);</pre>

<p>There are a series of methods available in the {{domxref("MediaRecorder")}} interface that allow you to control recording of the media stream; in Web Dictaphone we just make use of two, and listen to some events. First of all, {{domxref("MediaRecorder.start()")}} is used to start recording the stream once the record button is pressed:</p>

<pre class="brush: js notranslate">record.onclick = function() {
  mediaRecorder.start();
  console.log(mediaRecorder.state);
  console.log("recorder started");
  record.style.background = "red";
  record.style.color = "black";
}</pre>

<p>When the <code>MediaRecorder</code> is recording, the {{domxref("MediaRecorder.state")}} property will return a value of "recording".</p>

<p>As recording progresses, we need to collect the audio data. We register an event handler to do this using {{domxref("mediaRecorder.ondataavailable")}}:</p>

<pre class="brush: js notranslate">let chunks = [];

mediaRecorder.ondataavailable = function(e) {
  <span class="pl-smi">chunks</span>.<span class="pl-c1">push</span>(<span class="pl-smi">e</span>.<span class="pl-c1">data</span>);
}</pre>

<div class="notecard note">
<p><strong>Note</strong>: The browser will fire <code>dataavailable</code> events as needed, but if you want to intervene you can also include a timeslice when invoking the <code>start()</code> method — for example <code>start(10000)</code> — to control this interval, or call {{domxref("MediaRecorder.requestData()")}} to trigger an event when you need it.</p>
</div>

<p>Lastly, we use the {{domxref("MediaRecorder.stop()")}} method to stop the recording when the stop button is pressed, and finalize the {{domxref("Blob")}} ready for use somewhere else in our application.</p>

<pre class="brush: js notranslate">stop.onclick = function() {
  mediaRecorder.stop();
  console.log(mediaRecorder.state);
  console.log("recorder stopped");
  record.style.background = "";
  record.style.color = "";
}</pre>

<p>Note that the recording may also stop naturally if the media stream ends (e.g. if you were grabbing a song track and the track ended, or the user stopped sharing their microphone).</p>

<h2 id="Grabbing_and_using_the_blob">Grabbing and using the blob</h2>

<p>When recording has stopped, the <code>state</code> property returns a value of "inactive", and a stop event is fired. We register an event handler for this using {{domxref("mediaRecorder.onstop")}}, and finalize our blob there from all the chunks we have received:</p>

<pre class="brush: js notranslate">mediaRecorder.onstop = function(e) {
  console.log("recorder stopped");

  const clipName = prompt('Enter a name for your sound clip');

  const clipContainer = document.createElement('article');
  const clipLabel = document.createElement('p');
  const audio = document.createElement('audio');
  const deleteButton = document.createElement('button');

  clipContainer.classList.add('clip');
  audio.setAttribute('controls', '');
  deleteButton.innerHTML = "Delete";
  clipLabel.innerHTML = clipName;

  clipContainer.appendChild(audio);
  clipContainer.appendChild(clipLabel);
  clipContainer.appendChild(deleteButton);
  soundClips.appendChild(clipContainer);

  const blob = new Blob(chunks, { 'type' : 'audio/ogg; codecs=opus' });
  chunks = [];
  const audioURL = window.URL.createObjectURL(blob);
  audio.src = audioURL;

  deleteButton.onclick = function(e) {
    let evtTgt = e.target;
    evtTgt.parentNode.parentNode.removeChild(evtTgt.parentNode);
  }
}</pre>

<p>Let's go through the above code and look at what's happening.</p>

<p>First, we display a prompt asking the user to name their clip.</p>

<p>Next, we create an HTML structure like the following, inserting it into our clip container, which is an {{htmlelement("article")}} element.</p>

<pre class="brush: html notranslate">&lt;article class="clip"&gt;
  &lt;audio controls&gt;&lt;/audio&gt;
  &lt;p&gt;<em>your clip name</em>&lt;/p&gt;
  &lt;button&gt;Delete&lt;/button&gt;
&lt;/article&gt;</pre>

<p>After that, we create a combined {{domxref("Blob")}} out of the recorded audio chunks, and create an object URL pointing to it, using <code>window.URL.createObjectURL(blob)</code>. We then set the value of the {{HTMLElement("audio")}} element's {{htmlattrxref("src", "audio")}} attribute to the object URL, so that when the play button is pressed on the audio player, it will play the <code>Blob</code>.</p>

<p>Finally, we set an <code>onclick</code> handler on the delete button to be a function that deletes the whole clip HTML structure.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("MediaStream Recording", "#MediaRecorderAPI")}}</td>
   <td>{{Spec2("MediaStream Recording")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="MediaRecorder"><code>MediaRecorder</code></h3>

<p>{{Compat("api.MediaRecorder")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaRecorder_API">MediaRecorder API</a> landing page</li>
 <li><code>{{domxref("Navigator.getUserMedia()")}}</code></li>
 <li><a href="https://addpipe.com/blog/media-recorder-api-is-now-supported-by-65-of-all-desktop-internet-users/">MediaRecorder API now supported by 65% of your website users</a></li>
</ul>
